
Public Class frm_Diag

    Dim mpbi() As PictureBox    'Input PictureBox Control's Array
    Dim mpbo() As CheckBox   'Output CheckBox  Control's Array
    Dim YScale() As TextBox   'YSacle TextBox  Control's Array



    Public wTotalBoards As UInt32
    Dim wRtn As UInt16
    Dim wBoardNo As UInt16
    Dim wChannel As UInt16
    Dim wConfig As UInt16

    Dim dwDataNum As UInt32
    Dim YS!(0 To 1)
    Dim fRangeMax As Single
    Dim fRangeMin As Single
    Dim fBuf(0 To 999) As Double
    Dim lBuf(0 To 999) As UInt32

    Dim sModelName(0 To 30) As Byte

    Dim lAIRate As UInt32
    Dim iGain As UInt16

    Friend sCardInfo(32) As PCIELM4_CARD_INFO
    Friend sDevInfo(32) As PCIELM4_DEVICE_INFO

    Dim sSelDevInfo As PCIELM4_DEVICE_INFO
    Dim sSelCardInfo As PCIELM4_CARD_INFO
   

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim wBoardIndex As UInt16

        dwDataNum = CInt(Me.tbxDataNum.Text)


        '//Driver Initial
        wRtn = PCIELM4_DriverInit(wTotalBoards)


        If (wRtn) Then
            MsgBox("Driver Initial Error!!Error Code:" + Str(wRtn))
            End
        End If


        '//Get Card Information
        For wBoardIndex = 0 To wTotalBoards - 1

            wRtn = PCIELM4_GetCardInfo(wBoardIndex, sDevInfo(wBoardIndex), sCardInfo(wBoardIndex), sModelName)

            If (wRtn) Then
                MsgBox("Get Card Information Err")
            End If

            Me.cbxBoardNo.Items.Add(Str(wBoardIndex) + " " + System.Text.Encoding.ASCII.GetString(sModelName))
        Next

        mpbo = CType(ControlArrayUtils.getControlArray(Me.gbxIO, "cbOut"), CheckBox())
        mpbi = CType(ControlArrayUtils.getControlArray(Me.gbxIO, "pbIn"), PictureBox())
        YScale = CType(ControlArrayUtils.getControlArray(Me.frmAI, "YScale"), TextBox())


        Dim i As Short
        For i = 1 To 16

            mpbi(i).Image = My.Resources.gray

            mpbi(i).Enabled = False
            mpbi(i).SizeMode = PictureBoxSizeMode.StretchImage

            mpbo(i).Enabled = False

            AddHandler mpbo(i).Click, AddressOf SignalOutput

        Next


        Me.cbxBoardNo.SelectedIndex = 0



    End Sub
    '//For checkbox control array Handle, and Digital Output control
    Private Sub SignalOutput(ByVal sender As System.Object, ByVal e As System.EventArgs)

        Dim DoVal As UInt32
        Dim index As UInt16

        DoVal = 0

        For index = 1 To 16
            If mpbo(index).Checked Then

                DoVal = DoVal Or Math.Pow(2, index - 1)

            End If
        Next


        wRtn = PCIELM4_WriteDO(wBoardNo, DoVal)
        If (wRtn) Then
            MsgBox("Write DO port Error!!!")
        End If


    End Sub

    Private Sub cmdActive_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdActive.Click
        Dim index As UInt16

        wBoardNo = Me.cbxBoardNo.SelectedIndex
        wChannel = Me.cbxAICh.SelectedIndex
        wConfig = Me.cbxAICfgCode.SelectedIndex


        If cmdActive.Text = "&ACTIVE" Then
            cmdActive.Text = "&STOP"
            cmdExit.Enabled = False

            Me.tmrDI.Enabled = True

            For index = 1 To 16
                mpbo(index).Enabled = True

            Next

        Else
            cmdActive.Text = "&ACTIVE"

            cmdExit.Enabled = True
            Me.tmrDI.Enabled = False

            For index = 1 To 16
                mpbo(index).Enabled = False

            Next
        End If
    End Sub

    Private Sub cbxBoardNo_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxBoardNo.SelectedIndexChanged
        Dim AIChIndex As UInt16
        sSelDevInfo = sDevInfo(cbxBoardNo.SelectedIndex)
        sSelCardInfo = sCardInfo(cbxBoardNo.SelectedIndex)

        Me.Text = Me.cbxBoardNo.Text + " Motor Card Diag[ID:" + CStr(sSelCardInfo.CardID) + "]"


        If (sSelCardInfo.wAIChannels) Then

            For AIChIndex = 0 To sSelCardInfo.wAIChannels - 1

                If AIChIndex < 4 Then
                    cbxAICh.Items.Add("CH" + CStr(AIChIndex) + "[Load Cell]")
                Else
                    cbxAICh.Items.Add("CH" + CStr(AIChIndex) + "[General]")
                End If
            Next
            cbxAICh.SelectedIndex = 4
            cbxAIRate.SelectedIndex = 6
            Me.cbxAICfgCode.SelectedIndex = 1
        End If

        wRtn = PCIELM4_ConfigAO(0, 0, 0, PCIELM4_AO_BI_10V)

        If (wRtn) Then
            MsgBox("Config AO0 Error Error Code:0x" + Hex(wRtn))
        End If

        wRtn = PCIELM4_ConfigAO(0, 1, 0, PCIELM4_AO_BI_10V)

        If (wRtn) Then
            MsgBox("Config AO1 Error Error Code:0x" + Hex(wRtn))
        End If

    End Sub

    Private Sub cmdExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExit.Click
        wRtn = PCIELM4_DriverClose()
        If wRtn Then
            MsgBox("Driver Close Error Code : " + Str(wRtn))
        End If
        End
    End Sub


    Private Sub tmrDI_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrDI.Tick

        Dim wInputVal As UInt32
        Dim index As UInt16
      



        '//Read Digital Input port Val
        wRtn = PCIELM4_ReadDI(wBoardNo, wInputVal)
        If (wRtn) Then
            MsgBox("Read DI port Error!!!")
        End If


        For index = 1 To 16

            If CBool(wInputVal And (Math.Pow(2, (index - 1)))) Then
                mpbi(CInt(index)).Image = My.Resources.red
            Else
                mpbi(CInt(index)).Image = My.Resources.gray
            End If
        Next

    End Sub



    Private Sub cmdAOCH0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAOCH0.Click
        Dim wDaOutputNum As UInt32
        Dim wIndex As UInt32
        Dim fDAVal(0 To 511) As Single
        Dim dwDAVal(0 To 511) As UInt32
        Dim HEXtoInt As Long

        If Me.cmdAOCH0.Text = "Active" Then
            Me.optDC.Enabled = False
            Me.optSin.Enabled = False
            Me.optDAhex.Enabled = False
            Me.optDAVol.Enabled = False
        End If

        wRtn = PCIELM4_ConfigAO(wBoardNo, 0, 0, PCIELM4_AO_BI_10V)

        If (wRtn) Then
            MsgBox("Config AO0 Error Error Code:0x" + Hex(wRtn))
        End If

        Me.List1.Items.Clear()

        '//Static
        If Me.optDC.Checked = True Then

            If (Me.optDAhex.Checked = True) Then
                wRtn = PCIELM4_WriteAOVoltageH(wBoardNo, 0, CLng("&h" + (Me.tbxAOCH0Val.Text)))
            Else
                wRtn = PCIELM4_WriteAOVoltage(wBoardNo, 0, CSng(Me.tbxAOCH0Val.Text))
            End If
            If (wRtn) Then
                MsgBox("Write AO Error Error Code:0x" + Hex(wRtn))
            End If
        Else '//Wave generator

            Me.cmdAOStop.Enabled = True
            Me.cmdAOCH0.Enabled = False
            wDaOutputNum = 500

            If (Me.optDAhex.Checked = True) Then


                HEXtoInt = Val("&H" & Me.tbxAOCH0Val.Text)
                If HEXtoInt < 0 Then
                    HEXtoInt = HEXtoInt + 65535
                End If
                For wIndex = 0 To wDaOutputNum - 1
                    fDAVal(wIndex) = ((HEXtoInt / 65535) * (fRangeMax - fRangeMin) + fRangeMin) * Math.Sin((2 * 3.14159 / wDaOutputNum) * wIndex)
                    dwDAVal(wIndex) = CLng(((fDAVal(wIndex) - fRangeMin) / (fRangeMax - fRangeMin)) * 65535)

                    Me.List1.Items.Add(CStr(wIndex) + " " + Hex(dwDAVal(wIndex)))
                Next

                '//Start DA Pattern Generatorwith Continuous Mode
                wRtn = PCIELM4_StartAOVoltageALLH(wBoardNo, CSng(Me.tbxAOfreq.Text) * CSng(wDaOutputNum), wDaOutputNum, 0, dwDAVal, dwDAVal)
            Else
                For wIndex = 0 To wDaOutputNum - 1
                    fDAVal(wIndex) = CSng(Me.tbxAOCH0Val.Text) * Math.Sin((2 * 3.14159 / wDaOutputNum) * wIndex) '+ CSng(Me.tbxOffset.Text)
                    Me.List1.Items.Add(CStr(wIndex) + " " + Format(fDAVal(wIndex), "##.000"))

                Next

                '//Start DA Pattern Generatorwith Continuous Mode
                wRtn = PCIELM4_StartAOVoltageALL(wBoardNo, CSng(Me.tbxAOfreq.Text) * CSng(wDaOutputNum), wDaOutputNum, 0, fDAVal, fDAVal)

            End If


            If (wRtn) Then
                Me.cmdAOStop.Enabled = False
                Me.cmdAOCH0.Enabled = True
                MsgBox("Write AO Error Error Code:0x" + Hex(wRtn))
            End If
        End If
    End Sub

    Private Sub optDAhex_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optDAhex.CheckedChanged
        Me.lblDACH0Type.Text = "HEX"
   
    End Sub

    Private Sub optDAVol_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optDAVol.CheckedChanged
        Me.lblDACH0Type.Text = "V"

        Me.optSin.Enabled = True
    End Sub

    Private Sub optDA1hex_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optDA1hex.CheckedChanged
        Me.lblDACH1Type.Text = "HEX"
    End Sub

    Private Sub optDA1Vol_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optDA1Vol.CheckedChanged
        Me.lblDACH1Type.Text = "V"
    End Sub

    Private Sub optDC_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optDC.CheckedChanged
        Me.cmdAOCH0.Text = "Output DC"
        Me.cmdAOStop.Enabled = False
    End Sub

    Private Sub optSin_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optSin.CheckedChanged
        Me.cmdAOCH0.Text = "Active"
        Me.cmdAOStop.Enabled = False
    End Sub

    Private Sub cmdAOStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAOStop.Click
        wRtn = PCIELM4_StopAOALL(wBoardNo)

        Me.cmdAOCH0.Enabled = True

        If Me.cmdAOCH0.Text = "Active" Then
            Me.optDC.Enabled = True
            Me.optSin.Enabled = True
            Me.optDAhex.Enabled = True
            Me.optDAVol.Enabled = True
        End If
    End Sub

    Private Sub cmdAOCH1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAOCH1.Click
        wRtn = PCIELM4_ConfigAO(0, 1, 0, PCIELM4_AO_BI_10V)

        If (wRtn) Then
            MsgBox("Config AO1 Error Error Code:0x" + Hex(wRtn))
        End If



        If (Me.optDA1hex.Checked = True) Then
            wRtn = PCIELM4_WriteAOVoltageH(wBoardNo, 1, CLng("&h" + (Me.tbxAOCH1Val.Text)))
        Else
            wRtn = PCIELM4_WriteAOVoltage(wBoardNo, 1, CSng(Me.tbxAOCH1Val.Text))
        End If
        If (wRtn) Then
            MsgBox("Write AO Error Error Code:0x" + Hex(wRtn))
        End If

    End Sub

    Private Sub tbxDataNum_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbxDataNum.TextChanged
        dwDataNum = Val(Me.tbxDataNum.Text)
    End Sub



  
 
    Private Sub cbxAIRate_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxAIRate.SelectedIndexChanged
        Select Case cbxAIRate.SelectedIndex

            Case 0
                lAIRate = PCIELM4_AIRATE_15000
            Case 1
                lAIRate = PCIELM4_AIRATE_7500
            Case 2
                lAIRate = PCIELM4_AIRATE_3750
            Case 3
                lAIRate = PCIELM4_AIRATE_1000
            Case 4
                lAIRate = PCIELM4_AIRATE_500
            Case 5
                lAIRate = PCIELM4_AIRATE_30
            Case 6
                lAIRate = PCIELM4_AIRATE_15


        End Select
    End Sub

    Private Sub cbxAICfgCode_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxAICfgCode.SelectedIndexChanged

        Select Case cbxAICfgCode.SelectedIndex

            Case PCIELM4_AI_BI_10V
                fRangeMax = 10.0#
                fRangeMin = -10.0#

            Case PCIELM4_AI_BI_5V      '1  //Bipolar +/-  5V
                fRangeMax = 5.0#
                fRangeMin = -5.0#

            Case PCIELM4_AI_BI_2V5     '2 //Bipolar +/-  2.5V
                fRangeMax = 2.5
                fRangeMin = -2.5

            Case PCIELM4_AI_BI_1V25    '3 //Bipolar +/-  1.25V
                fRangeMax = 1.25
                fRangeMin = -1.25
            Case 4
                fRangeMax = 227.3#
                fRangeMin = -227.3#

        End Select
        YS(0) = fRangeMax * 1.1
        YScale(0).Text = Format(fRangeMax * 1.1, "#0.000")

        YS(1) = fRangeMin * 1.1
        YScale(1).Text = Format(fRangeMin * 1.1, "#0.000")


        Me.optAIFloat.Text = "V"
   
    End Sub

    Private Sub cbxAICh_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbxAICh.SelectedIndexChanged
        If Me.cbxAICh.SelectedIndex < 4 Then
            Me.cbxAICfgCode.Enabled = False
            iGain = 1000

            fRangeMax = 0.2273 * iGain * 1.1
            fRangeMin = -0.2273 * iGain * 1.1

            YScale(0).Text = Format(fRangeMax, "#0.000")
            YS(0) = fRangeMax

            YScale(1).Text = Format(fRangeMin, "#0.000")
            YS(1) = fRangeMin

   


            Me.chkAutoZeroEnable.Visible = True
            Me.tbxAutoZeroVal.Visible = True
            Me.cmdSaveAutozeroVal.Visible = True
            cbxAICfgCode.SelectedIndex = 0
            cbxAICfgCode.SelectedIndex = 4
            Me.optAIFloat.Text = "mV"
        Else
            iGain = 1
            Me.chkAutoZeroEnable.Visible = False
            Me.tbxAutoZeroVal.Visible = False
            Me.cmdSaveAutozeroVal.Visible = False
            Me.cbxAICfgCode.Enabled = True
            Me.cbxAICfgCode.SelectedIndex = 1
            Me.optAIFloat.Text = "V"
            cbxAICfgCode.SelectedIndex = 0
            cbxAICfgCode.SelectedIndex = 1
        End If
    End Sub

    Private Sub cmdAITrigger_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAITrigger.Click

        Dim i As Integer
        Dim gr As Graphics = pbxDisplay.CreateGraphics()

        wBoardNo = Me.cbxBoardNo.SelectedIndex
        wChannel = Me.cbxAICh.SelectedIndex
        wConfig = Me.cbxAICfgCode.SelectedIndex
        If (wConfig = 4) Then
            wConfig = PCIELM4_AI_BI_227MV
        End If


        Me.cmdAITrigger.Enabled = False
        Me.List1.Items.Clear()
        wRtn = PCIELM4_ConfigAI(wBoardNo, 0, 0, 0, 0, 0)
        If (Me.optAIHex.Checked = True) Then
            '//Get the A/D data on Software Polling Mode
            wRtn = PCIELM4_PollingAIH(wBoardNo, wChannel, wConfig, lAIRate, dwDataNum, lBuf)
            For i = 0 To dwDataNum - 1

                If (lBuf(i) >= 0) And lBuf(i) < &H800000 Then

                    fBuf(i) = CDbl((fRangeMax - fRangeMin) / 2) * (CDbl(lBuf(i)) / CDbl(&H7FFFFF))
                Else
                    fBuf(i) = CDbl((fRangeMax - fRangeMin) / 2) * (CDbl(lBuf(i) - CDbl(&HFFFFFF)) / CDbl(&H7FFFFF))
                End If
                If Me.cbxAICh.SelectedIndex < 4 Then
                    fBuf(i) = fBuf(i) / 1000.0
                End If
            Next
        Else
            'wRtn = PCIELM4_ConfigAI(wBoardNo, 0, 0, 0, 0, 0)
            '//Get the A/D data on Software Polling Mode
            wRtn = PCIELM4_PollingAI(wBoardNo, wChannel, wConfig, lAIRate, dwDataNum, fBuf)
        End If
        If (wRtn) Then
            MsgBox("AD Polling Error|!Error Code:" + Str(wRtn))
            Me.cmdAITrigger.Enabled = True
            Exit Sub
        End If

        fBuf(0) = fBuf(0) * iGain
        '//Draw the Wave

        If (Me.optAIHex.Checked = True) Then
            Me.List1.Items.Add(Format(0, "000") + " &H" + Hex(lBuf(0)))
            Me.tbxAutoZeroVal.Text = Hex(lBuf(0))

        Else

            Me.List1.Items.Add("000" + " " + Format(fBuf(0), "00.000"))
        End If

        For i = 1 To dwDataNum - 1

            fBuf(i) = fBuf(i) * iGain


            If (Me.optAIHex.Checked = True) Then
                Me.List1.Items.Add(Format(i, "000") + " &H" + Hex(lBuf(i)))

            Else

                Me.List1.Items.Add(Format(i, "000") + " " + Format(fBuf(i), "00.000"))
            End If

        Next i

        If dwDataNum > 1 Then
            PlotData(gr)
        Else
            pbxDisplay.Refresh()
        End If

        Application.DoEvents()

        Me.cmdAITrigger.Enabled = True
    End Sub

    Private Sub PlotData(ByVal g As Graphics)

        Dim fScaleX As Single, fScaleY As Single
        Dim RedPen As New Pen(Color.Red)
        Dim BlackPen As New Pen(Color.Black)
        Dim PointArray(dwDataNum - 1) As PointF
        Dim LPointArray() As PointF
        Dim LBaseArray(1) As PointF
        Dim i As UInt16

        Dim YScaleUP As Single
        Dim YScaleDown As Single
        Select Case cbxAICfgCode.SelectedIndex

            Case PCIELM4_AI_BI_10V
                YScaleUP = 11.0#
                YScaleDown = -11.0#

            Case PCIELM4_AI_BI_5V      '1  //Bipolar +/-  5V
                YScaleUP = 5.5#
                YScaleDown = -5.5#

            Case PCIELM4_AI_BI_2V5     '2 //Bipolar +/-  2.5V
                YScaleUP = 2.75#
                YScaleDown = -2.75#

            Case PCIELM4_AI_BI_1V25    '3 //Bipolar +/-  1.25V
                YScaleUP = 1.375#
                YScaleDown = -1.375#

            Case 4                     '4 //Bipolar +/-  227mV
                YScaleUP = 227.3# * 1.1
                YScaleDown = -227.3# * 1.1
        End Select

        For i = PointArray.GetLowerBound(0) To PointArray.GetUpperBound(0)

            PointArray(i).X = i

            PointArray(i).Y = fBuf(i)

        Next

        ReDim LPointArray(PointArray.GetUpperBound(0))

        fScaleX = pbxDisplay.Width / PointArray.Length
        If optAIFloat.Checked Then
            fScaleY = CSng((pbxDisplay.Height * 0.97)) / (CSng(YScale0.Text) - CSng(YScale1.Text))
        Else

            fScaleY = CSng((pbxDisplay.Height * 0.97)) / (CSng(YScaleUP) - CSng(YScaleDown))

        End If

        For i = PointArray.GetLowerBound(0) To PointArray.GetUpperBound(0)

            LPointArray(i).X = PointArray(i).X * fScaleX

            If optAIFloat.Checked Then
                LPointArray(i).Y = ((Convert.ToSingle(YScale0.Text) - PointArray(i).Y) * fScaleY)
            Else

                LPointArray(i).Y = ((Convert.ToSingle(YScaleUP) - PointArray(i).Y) * fScaleY)

            End If

        Next

        pbxDisplay.Refresh()
        g.DrawLines(RedPen, LPointArray)


        RedPen.Dispose()

    End Sub

    Private Sub chkAutoZeroEnable_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkAutoZeroEnable.CheckedChanged
        If chkAutoZeroEnable.Checked = True Then
            wRtn = PCIELM4_ConfigAIAutoZero(wBoardNo, Me.cbxAICh.SelectedIndex, 1)
        Else
            wRtn = PCIELM4_ConfigAIAutoZero(wBoardNo, Me.cbxAICh.SelectedIndex, 0)
        End If
    End Sub

    Private Sub cmdSaveAutozeroVal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSaveAutozeroVal.Click
        wRtn = PCIELM4_SaveAIAutoZeroVal(wBoardNo, Me.cbxAICh.SelectedIndex, lAIRate, "&h" + Me.tbxAutoZeroVal.Text)
        If chkAutoZeroEnable.Checked = True Then
            wRtn = PCIELM4_ConfigAIAutoZero(wBoardNo, Me.cbxAICh.SelectedIndex, 1)
        End If
    End Sub

    Private Sub optAIHex_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles optAIHex.CheckedChanged
        
        If optAIHex.Checked Then
            Me.YScale(0).Text = "0x7FFFFF"
            Me.YScale(1).Text = "0x800000"
        Else
            Me.YScale(0).Text = Format(fRangeMax * 1.1, "#0.000")
            Me.YScale(1).Text = Format(fRangeMin * 1.1, "#0.000")
        End If

    End Sub
   
End Class
